package de.agrund.rssfeedreader.ui.parts;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.inject.Inject;

import org.eclipse.e4.ui.di.Focus;
import org.eclipse.swt.widgets.Composite;

import swing2swt.layout.BorderLayout;

import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.List;
import org.eclipse.jface.viewers.ListViewer;

import de.agrund.rssfeedreader.model.RssFeedModel;
import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.core.databinding.observable.map.IObservableMap;
import org.eclipse.core.databinding.beans.BeansObservables;
import de.agrund.rssfeedreader.model.RssFeedEntry;
import org.eclipse.jface.databinding.viewers.ObservableMapLabelProvider;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.beans.PojoProperties;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

public class FeedViewPart {
	private DataBindingContext m_bindingContext;
	
	@Inject
	private RssFeedModel rssFeedModel;
	private ListViewer listViewer;

	public FeedViewPart() {
	}

	/**
	 * Create contents of the view part.
	 */
	@PostConstruct
	public void createControls(Composite parent) {
		parent.setLayout(new BorderLayout(0, 0));
		
		Button btnUpdateFeed = new Button(parent, SWT.NONE);
		btnUpdateFeed.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				rssFeedModel.addFeedEntry(new RssFeedEntry("Dies ist ein Text", true));
			}
		});
		btnUpdateFeed.setLayoutData(BorderLayout.SOUTH);
		btnUpdateFeed.setText("Update Feed");
		
		listViewer = new ListViewer(parent, SWT.BORDER | SWT.V_SCROLL);
		List list = listViewer.getList();
		list.setLayoutData(BorderLayout.CENTER);
		m_bindingContext = initDataBindings();
	}

	@PreDestroy
	public void dispose() {
	}

	@Focus
	public void setFocus() {
		// TODO	Set the focus to control
	}

	protected DataBindingContext initDataBindings() {
		DataBindingContext bindingContext = new DataBindingContext();
		//
		ObservableListContentProvider listContentProvider = new ObservableListContentProvider();
		IObservableMap observeMap = BeansObservables.observeMap(listContentProvider.getKnownElements(), RssFeedEntry.class, "text");
		listViewer.setLabelProvider(new ObservableMapLabelProvider(observeMap));
		listViewer.setContentProvider(listContentProvider);
		//
		IObservableList feedEntriesRssFeedModelObserveList = PojoProperties.list("feedEntries").observe(rssFeedModel);
		listViewer.setInput(feedEntriesRssFeedModelObserveList);
		//
		return bindingContext;
	}
}
